/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.92 Revision 1.119
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.92 2005/08/01 10:50:55 kevquinn Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.119 2007/05/12 11:45:51 vapier Exp $
4 4#
5# Maintainer: toolchain@gentoo.org
5 6
6# need access to emktemp() 7# need access to emktemp()
7inherit eutils toolchain-funcs multilib 8inherit eutils toolchain-funcs multilib
8 9
9# 10#
19# 20#
20#### replace-cpu-flags <old.cpus> <new.cpu> ### 21#### replace-cpu-flags <old.cpus> <new.cpu> ###
21# Replace march/mcpu flags that specify <old.cpus> 22# Replace march/mcpu flags that specify <old.cpus>
22# with flags that specify <new.cpu> 23# with flags that specify <new.cpu>
23# 24#
24#### is-flag <flag> #### 25#### is-flag[q] <flag> ####
25# Returns "true" if flag is set in C[XX]FLAGS 26# Returns "true" if flag is set in C[XX]FLAGS
26# Matches only complete a flag 27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
27# 34#
28#### strip-flags #### 35#### strip-flags ####
29# Strip C[XX]FLAGS of everything except known 36# Strip C[XX]FLAGS of everything except known
30# good options. 37# good options.
31# 38#
50# 57#
51#### filter-ldflags <flags> #### 58#### filter-ldflags <flags> ####
52# Remove particular flags from LDFLAGS 59# Remove particular flags from LDFLAGS
53# Matches only complete flags 60# Matches only complete flags
54# 61#
55#### fstack-flags #### 62#### bindnow-flags ####
56# hooked function for hardened gcc that appends 63# Returns the flags to enable "now" binding in the current selected linker.
57# -fno-stack-protector to {C,CXX,LD}FLAGS
58# when a package is filtering -fstack-protector, -fstack-protector-all
59# notice: modern automatic specs files will also suppress -fstack-protector-all
60# when only -fno-stack-protector is given
61#
62# 64#
63################ DEPRECATED functions ################ 65################ DEPRECATED functions ################
64# The following are still present to avoid breaking existing 66# The following are still present to avoid breaking existing
65# code more than necessary; however they are deprecated. Please 67# code more than necessary; however they are deprecated. Please
66# use gcc-specs-* from toolchain-funcs.eclass instead, if you 68# use gcc-specs-* from toolchain-funcs.eclass instead, if you
88# Returns true if the compiler by default or with current CFLAGS 90# Returns true if the compiler by default or with current CFLAGS
89# generates stack smash protections for most vulnerable functions 91# generates stack smash protections for most vulnerable functions
90# 92#
91 93
92# C[XX]FLAGS that we allow in strip-flags 94# C[XX]FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed
93setup-allowed-flags() { 96setup-allowed-flags() {
94 if [[ -z ${ALLOWED_FLAGS} ]] ; then 97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
95 export ALLOWED_FLAGS="-pipe" 98 export ALLOWED_FLAGS="-pipe"
96 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune" 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
97 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all" 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
98 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking" 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-pie -fno-unit-at-a-time" 102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g0 -g1 -g2 -g3 -ggdb -ggdb0 -ggdb1 -ggdb2 -ggdb3" 103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
101 fi 105 fi
102 # allow a bunch of flags that negate features / control ABI 106 # allow a bunch of flags that negate features / control ABI
103 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all" 107 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
108 -fno-strict-aliasing -fno-bounds-checking"
104 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \ 109 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
105 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \ 110 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
106 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \ 111 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
107 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \ 112 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
108 -mieee -mieee-with-inexact \ 113 -mieee -mieee-with-inexact -mschedule \
109 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \ 114 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
110 -mflat -mno-flat -mno-faster-structs -mfaster-structs \ 115 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
111 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \ 116 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
112 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias" 117 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
118 -msecure-plt -D*"
113 119
114 # C[XX]FLAGS that we are think is ok, but needs testing 120 # C[XX]FLAGS that we are think is ok, but needs testing
115 # NOTE: currently -Os have issues with gcc3 and K6* arch's 121 # NOTE: currently -Os have issues with gcc3 and K6* arch's
116 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 122 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
117 return 0 123 return 0
124}
125
126# inverted filters for hardened compiler. This is trying to unpick
127# the hardened compiler defaults.
128_filter-hardened() {
129 local f
130 for f in "$@" ; do
131 case "${f}" in
132 # Ideally we should only concern ourselves with PIE flags,
133 # not -fPIC or -fpic, but too many places filter -fPIC without
134 # thinking about -fPIE.
135 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
136 gcc-specs-pie || continue
137 is-flagq -nopie || append-flags -nopie;;
138 -fstack-protector)
139 gcc-specs-ssp || continue
140 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
141 -fstack-protector-all)
142 gcc-specs-ssp-to-all || continue
143 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
144 esac
145 done
146}
147
148# Remove occurrences of strings from variable given in $1
149# Strings removed are matched as globs, so for example
150# '-O*' would remove -O1, -O2 etc.
151_filter-var() {
152 local f x VAR VAL
153 declare -a new
154
155 VAR=$1
156 shift
157 eval VAL=\${${VAR}}
158 for f in ${VAL}; do
159 for x in "$@"; do
160 # Note this should work with globs like -O*
161 [[ ${f} == ${x} ]] && continue 2
162 done
163 eval new\[\${\#new\[@]}]=\${f}
164 done
165 eval export ${VAR}=\${new\[*]}
118} 166}
119 167
120filter-flags() { 168filter-flags() {
121 local x f fset 169 _filter-hardened "$@"
122 declare -a new_CFLAGS new_CXXFLAGS 170 _filter-var CFLAGS "$@"
123 171 _filter-var CPPFLAGS "$@"
124 for x in "$@" ; do 172 _filter-var CXXFLAGS "$@"
125 case "${x}" in
126 -fPIC|-fpic|-fPIE|-fpie|-pie)
127 append-flags `test_flag -fno-pie`;;
128 -fstack-protector|-fstack-protector-all)
129 fstack-flags;;
130 esac
131 done
132
133 for fset in CFLAGS CXXFLAGS; do
134 # Looping over the flags instead of using a global
135 # substitution ensures that we're working with flag atoms.
136 # Otherwise globs like -O* have the potential to wipe out the
137 # list of flags.
138 for f in ${!fset}; do
139 for x in "$@"; do
140 # Note this should work with globs like -O*
141 [[ ${f} == ${x} ]] && continue 2
142 done
143 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
144 done
145 eval export ${fset}=\${new_${fset}\[*]}
146 done
147
148 return 0 173 return 0
149} 174}
150 175
151filter-lfs-flags() { 176filter-lfs-flags() {
177 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
152 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 178 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
153} 179}
154 180
181append-cppflags() {
182 [[ -z $* ]] && return 0
183 export CPPFLAGS="${CPPFLAGS} $*"
184 return 0
185}
186
155append-lfs-flags() { 187append-lfs-flags() {
188 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
156 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 189 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
157} 190}
158 191
159append-flags() { 192append-flags() {
160 [[ -z $* ]] && return 0 193 [[ -z $* ]] && return 0
161 export CFLAGS="${CFLAGS} $*" 194 export CFLAGS="${CFLAGS} $*"
162 export CXXFLAGS="${CXXFLAGS} $*" 195 export CXXFLAGS="${CXXFLAGS} $*"
163 [ -n "`is-flag -fno-stack-protector`" -o \
164 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags
165 return 0 196 return 0
166} 197}
167 198
168replace-flags() { 199replace-flags() {
200 [[ $# != 2 ]] \
201 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
202 && die "replace-flags takes 2 arguments, not $#"
203
169 local f fset 204 local f fset
170 declare -a new_CFLAGS new_CXXFLAGS 205 declare -a new_CFLAGS new_CXXFLAGS
171 206
172 for fset in CFLAGS CXXFLAGS; do 207 for fset in CFLAGS CXXFLAGS; do
173 # Looping over the flags instead of using a global 208 # Looping over the flags instead of using a global
187 222
188replace-cpu-flags() { 223replace-cpu-flags() {
189 local newcpu="$#" ; newcpu="${!newcpu}" 224 local newcpu="$#" ; newcpu="${!newcpu}"
190 while [ $# -gt 1 ] ; do 225 while [ $# -gt 1 ] ; do
191 # quote to make sure that no globbing is done (particularly on 226 # quote to make sure that no globbing is done (particularly on
192 # ${oldcpu} prior to calling replace-flags 227 # ${oldcpu}) prior to calling replace-flags
193 replace-flags "-march=${1}" "-march=${newcpu}" 228 replace-flags "-march=${1}" "-march=${newcpu}"
194 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}" 229 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
195 replace-flags "-mtune=${1}" "-mtune=${newcpu}" 230 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
196 shift 231 shift
197 done 232 done
198 return 0 233 return 0
199} 234}
200 235
236_is_flagq() {
237 local x
238 for x in ${!1} ; do
239 [[ ${x} == $2 ]] && return 0
240 done
241 return 1
242}
243
244is-flagq() {
245 [[ -n $2 ]] && die "Usage: is-flag <flag>"
246 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
247}
248
201is-flag() { 249is-flag() {
202 local x 250 is-flagq "$@" && echo true
251}
203 252
204 for x in ${CFLAGS} ${CXXFLAGS} ; do 253is-ldflagq() {
205 # Note this should work with globs like -mcpu=ultrasparc* 254 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
206 if [[ ${x} == ${1} ]]; then 255 _is_flagq LDFLAGS $1
207 echo true 256}
208 return 0 257
209 fi 258is-ldflag() {
210 done 259 is-ldflagq "$@" && echo true
211 return 1
212} 260}
213 261
214filter-mfpmath() { 262filter-mfpmath() {
215 local orig_mfpmath new_math prune_math 263 local orig_mfpmath new_math prune_math
216 264
217 # save the original -mfpmath flag 265 # save the original -mfpmath flag
218 orig_mfpmath="`get-flag -mfpmath`" 266 orig_mfpmath=$(get-flag -mfpmath)
219 # get the value of the current -mfpmath flag 267 # get the value of the current -mfpmath flag
220 new_math=" `get-flag mfpmath | tr , ' '` " 268 new_math=$(get-flag mfpmath)
269 new_math=" ${new_math//,/ } "
221 # figure out which math values are to be removed 270 # figure out which math values are to be removed
222 prune_math="" 271 prune_math=""
223 for prune_math in "$@" ; do 272 for prune_math in "$@" ; do
224 new_math="${new_math/ ${prune_math} / }" 273 new_math=${new_math/ ${prune_math} / }
225 done 274 done
226 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 275 new_math=$(echo ${new_math})
276 new_math=${new_math// /,}
227 277
228 if [ -z "${new_math}" ] ; then 278 if [[ -z ${new_math} ]] ; then
229 # if we're removing all user specified math values are 279 # if we're removing all user specified math values are
230 # slated for removal, then we just filter the flag 280 # slated for removal, then we just filter the flag
231 filter-flags ${orig_mfpmath} 281 filter-flags ${orig_mfpmath}
232 else 282 else
233 # if we only want to filter some of the user specified 283 # if we only want to filter some of the user specified
285 export CFLAGS="${NEW_CFLAGS}" 335 export CFLAGS="${NEW_CFLAGS}"
286 export CXXFLAGS="${NEW_CXXFLAGS}" 336 export CXXFLAGS="${NEW_CXXFLAGS}"
287 return 0 337 return 0
288} 338}
289 339
340test-flag-PROG() {
341 local comp=$1
342 local flags="$2"
343
344 [[ -z ${comp} || -z ${flags} ]] && \
345 return 1
346
347 local PROG=$(tc-get${comp})
348 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
349 > /dev/null 2>&1
350}
351
352# Returns true if C compiler support given flag
353test-flag-CC() { test-flag-PROG "CC" "$1"; }
354
355# Returns true if C++ compiler support given flag
356test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
357
358test-flags-PROG() {
359 local comp=$1
360 local flags
361 local x
362
363 shift
364
365 [[ -z ${comp} ]] && return 1
366
367 x=""
368 for x in "$@" ; do
369 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
370 done
371
372 echo "${flags}"
373
374 # Just bail if we dont have any flags
375 [[ -n ${flags} ]]
376}
377
378# Returns (echo's) the given flags supported by the C compiler
379test-flags-CC() { test-flags-PROG "CC" "$@"; }
380
381# Returns (echo's) the given flags supported by the C++ compiler
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384# Short-hand that should hopefully work for both C and C++ compiler, but
385# its really only present due to the append-flags() abomination.
386test-flags() { test-flags-CC "$@"; }
387
388# Depriciated, use test-flags()
290test_flag() { 389test_flag() {
291 if $(tc-getCC) -S -xc "$@" -o "$(emktemp)" /dev/null &>/dev/null; then 390 ewarn "test_flag: deprecated, please use test-flags()!" >&2
292 printf "%s\n" "$*" 391
293 return 0 392 test-flags-CC "$@"
294 fi
295 return 1
296} 393}
297 394
298test_version_info() { 395test_version_info() {
299 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then 396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
300 return 0 397 return 0
302 return 1 399 return 1
303 fi 400 fi
304} 401}
305 402
306strip-unsupported-flags() { 403strip-unsupported-flags() {
307 local NEW_CFLAGS NEW_CXXFLAGS 404 export CFLAGS=$(test-flags-CC ${CFLAGS})
308 405 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
309 for x in ${CFLAGS} ; do
310 NEW_CFLAGS="${NEW_CFLAGS} `test_flag ${x}`"
311 done
312 for x in ${CXXFLAGS} ; do
313 NEW_CXXFLAGS="${NEW_CXXFLAGS} `test_flag ${x}`"
314 done
315
316 export CFLAGS="${NEW_CFLAGS}"
317 export CXXFLAGS="${NEW_CXXFLAGS}"
318} 406}
319 407
320get-flag() { 408get-flag() {
321 local f findflag="$1" 409 local f findflag="$1"
322 410
334 return 1 422 return 1
335} 423}
336 424
337# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs 425# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
338has_hardened() { 426has_hardened() {
427 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
428
339 test_version_info Hardened && return 0 429 test_version_info Hardened && return 0
340 # the specs file wont exist unless gcc has GCC_SPECS support 430 # The specs file wont exist unless gcc has GCC_SPECS support
341 [ -f "${GCC_SPECS}" -a "${GCC_SPECS}" != "${GCC_SPECS/hardened/}" ] && \ 431 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
342 return 0
343 return 1
344} 432}
345 433
346# DEPRECATED - use gcc-specs-pie from toolchain-funcs 434# DEPRECATED - use gcc-specs-pie from toolchain-funcs
347# indicate whether PIC is set 435# indicate whether PIC is set
348has_pic() { 436has_pic() {
349 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 437 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
350 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0 438
351 [ "$(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIC__)" ] && return 0 439 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
352 return 1 440 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
441 gcc-specs-pie
353} 442}
354 443
355# DEPRECATED - use gcc-specs-pie from toolchain-funcs 444# DEPRECATED - use gcc-specs-pie from toolchain-funcs
356# indicate whether PIE is set 445# indicate whether PIE is set
357has_pie() { 446has_pie() {
358 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 447 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
359 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 448
360 [ "$(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIE__)" ] && return 0 449 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
361 # test PIC while waiting for specs to be updated to generate __PIE__ 450 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
362 [ "$(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __PIC__)" ] && return 0 451 gcc-specs-pie
363 return 1
364} 452}
365 453
366# DEPRECATED - use gcc-specs-ssp from toolchain-funcs 454# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
367# indicate whether code for SSP is being generated for all functions 455# indicate whether code for SSP is being generated for all functions
368has_ssp_all() { 456has_ssp_all() {
457 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
458
369 # note; this matches only -fstack-protector-all 459 # note; this matches only -fstack-protector-all
370 [ "${CFLAGS/-fstack-protector-all}" != "${CFLAGS}" ] && return 0 460 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
371 [ "$(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__)" ] && return 0 461 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
372 gcc-specs-ssp && return 0 462 gcc-specs-ssp-all
373 return 1
374} 463}
375 464
376# DEPRECATED - use gcc-specs-ssp from toolchain-funcs 465# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
377# indicate whether code for SSP is being generated 466# indicate whether code for SSP is being generated
378has_ssp() { 467has_ssp() {
468 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
469
379 # note; this matches both -fstack-protector and -fstack-protector-all 470 # note; this matches both -fstack-protector and -fstack-protector-all
380 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0 471 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
381 [ "$(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__)" ] && return 0 472 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
382 gcc-specs-ssp && return 0 473 gcc-specs-ssp
383 return 1
384} 474}
385 475
386has_m64() { 476has_m64() {
387 # this doesnt test if the flag is accepted, it tests if the flag 477 # this doesnt test if the flag is accepted, it tests if the flag
388 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 478 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
389 # please dont replace this function with test_flag in some future 479 # please dont replace this function with test_flag in some future
390 # clean-up! 480 # clean-up!
481
391 local temp="$(emktemp)" 482 local temp="$(emktemp)"
392 echo "int main() { return(0); }" > ${temp}.c 483 echo "int main() { return(0); }" > "${temp}".c
393 MY_CC=$(tc-getCC) 484 MY_CC=$(tc-getCC)
394 ${MY_CC/ .*/} -m64 -o "$(emktemp)" ${temp}.c > /dev/null 2>&1 485 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
395 local ret=$? 486 local ret=$?
396 rm -f ${temp}.c 487 rm -f "${temp}".c
397 [ "$ret" != "1" ] && return 0 488 [[ ${ret} != 1 ]] && return 0
398 return 1 489 return 1
399} 490}
400 491
401has_m32() { 492has_m32() {
402 # this doesnt test if the flag is accepted, it tests if the flag 493 # this doesnt test if the flag is accepted, it tests if the flag
404 # please dont replace this function with test_flag in some future 495 # please dont replace this function with test_flag in some future
405 # clean-up! 496 # clean-up!
406 497
407 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0 498 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
408 499
409 local temp="$(emktemp)" 500 local temp=$(emktemp)
410 echo "int main() { return(0); }" > ${temp}.c 501 echo "int main() { return(0); }" > "${temp}".c
411 MY_CC=$(tc-getCC) 502 MY_CC=$(tc-getCC)
412 ${MY_CC/ .*/} -m32 -o "$(emktemp)" ${temp}.c > /dev/null 2>&1 503 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
413 local ret=$? 504 local ret=$?
414 rm -f ${temp}.c 505 rm -f "${temp}".c
415 [ "$ret" != "1" ] && return 0 506 [[ ${ret} != 1 ]] && return 0
416 return 1 507 return 1
417} 508}
418 509
419replace-sparc64-flags() { 510replace-sparc64-flags() {
420 local SPARC64_CPUS="ultrasparc v9" 511 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
421 512
422 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 513 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
423 for x in ${SPARC64_CPUS}; do 514 for x in ${SPARC64_CPUS}; do
424 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 515 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
425 done 516 done
426 else 517 else
427 for x in ${SPARC64_CPUS}; do 518 for x in ${SPARC64_CPUS}; do
428 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 519 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
429 done 520 done
430 fi 521 fi
431 522
432 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 523 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
433 for x in ${SPARC64_CPUS}; do 524 for x in ${SPARC64_CPUS}; do
434 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 525 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
435 done 526 done
436 else 527 else
437 for x in ${SPARC64_CPUS}; do 528 for x in ${SPARC64_CPUS}; do
438 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 529 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
439 done 530 done
440 fi 531 fi
441 532
442 export CFLAGS CXXFLAGS 533 export CFLAGS CXXFLAGS
443} 534}
444 535
445append-ldflags() { 536append-ldflags() {
537 [[ -z $* ]] && return 0
446 export LDFLAGS="${LDFLAGS} $*" 538 export LDFLAGS="${LDFLAGS} $*"
447 return 0 539 return 0
448} 540}
449 541
542# Remove flags from LDFLAGS - it's up to the ebuild to filter
543# CFLAGS and CXXFLAGS via filter-flags if they need to.
450filter-ldflags() { 544filter-ldflags() {
451 local x 545 _filter-var LDFLAGS "$@"
546 return 0
547}
452 548
453 # we do this fancy spacing stuff so as to not filter 549# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
454 # out part of a flag ... we want flag atoms ! :D 550# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
455 LDFLAGS=" ${LDFLAGS} " 551# to gcc where it needs the '-Wl,'.
552raw-ldflags() {
553 local x input="$@"
554 [[ -z ${input} ]] && input=${LDFLAGS}
555 set --
456 for x in "$@" ; do 556 for x in ${input} ; do
457 LDFLAGS=${LDFLAGS// ${x} / } 557 x=${x#-Wl,}
558 set -- "$@" ${x//,/ }
458 done 559 done
459 [[ -z ${LDFLAGS// } ]] \ 560 echo "$@"
460 && LDFLAGS="" \
461 || LDFLAGS=${LDFLAGS:1:${#LDFLAGS}-2}
462 export LDFLAGS
463 return 0
464} 561}
465 562
466fstack-flags() { 563# Gets the flags needed for "NOW" binding
467 if gcc-specs-ssp; then 564bindnow-flags() {
468 [ -z "`is-flag -fno-stack-protector`" ] && 565 case $($(tc-getLD) -v 2>&1 </dev/null) in
469 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 566 *GNU* | *'with BFD'*) # GNU ld
470 fi 567 echo "-Wl,-z,now" ;;
471 return 0 568 *Apple*) # Darwin ld
569 echo "-bind_at_load" ;;
570 *)
571 # Some linkers just recognize -V instead of -v
572 case $($(tc-getLD) -V 2>&1 </dev/null) in
573 *Solaris*) # Solaris accept almost the same GNU options
574 echo "-Wl,-z,now" ;;
575 esac
576 ;;
577 esac
472} 578}
473 579
474# This is thanks to great work from Paul de Vrieze <gentoo-user@devrieze.net>,
475# bug #9016. Also thanks to Jukka Salmi <salmi@gmx.net> (bug #13907) for more
476# fixes.
477#
478# Export CFLAGS and CXXFLAGS that are compadible with gcc-2.95.3
479gcc2-flags() {
480 if [[ $(tc-arch) == "x86" || $(tc-arch) == "amd64" ]] ; then
481 CFLAGS=${CFLAGS//-mtune=/-mcpu=}
482 CXXFLAGS=${CXXFLAGS//-mtune=/-mcpu=}
483 fi
484 580
485 replace-cpu-flags k6-{2,3} k6 581# Some tests for when we screw with things and want to make
486 replace-cpu-flags athlon{,-{tbird,4,xp,mp}} i686 582# sure we didn't break anything
487 583#TESTS() {
488 replace-cpu-flags pentium-mmx i586 584# CFLAGS="-a -b -c=1"
489 replace-cpu-flags pentium{2,3,4} i686 585# CXXFLAGS="-x -y -z=2"
490 586# LDFLAGS="-l -m -n=3"
491 replace-cpu-flags ev6{7,8} ev6 587#
492 588# die() { exit 1; }
493 export CFLAGS CXXFLAGS 589# (is-flag 1 2 3) && die
494} 590# (is-ldflag 1 2 3) && die
591#
592# is-flagq -l && die
593# is-ldflagq -a && die
594# is-flagq -a || die
595# is-flagq -x || die
596# is-ldflagq -n=* || die
597# is-ldflagq -n && die
598#
599# strip-unsupported-flags
600# [[ ${CFLAGS} == "-c=1" ]] || die
601# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
602#
603# echo "All tests pass"
604#}
605#TESTS

Legend:
Removed from v.1.92  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20